image: Visual Studio 2017
init:
  - git config --global core.autocrlf true
environment:
  matrix:
    - COMPILER: msvc
    - COMPILER: msys2
platform:
  - x86
  - x64
cache:
  - C:\ProgramData\chocolatey\bin -> .appveyor.yml
  - C:\ProgramData\chocolatey\lib -> .appveyor.yml
  - c:\tools\vcpkg\installed\ -> .appveyor.yml
install:
  - |-
    if %COMPILER% NEQ msvc set MSVC=rem
    if %COMPILER% NEQ msys2 set MSYS2=rem
    if exist %PREFIX% set DEP=rem
    if %PLATFORM%==x86 (set MSVC_PLATFORM=Win32) else set MSVC_PLATFORM=%PLATFORM%
    if %PLATFORM%==x64 set MSVC_GENERATOR_APPEND= Win64
    if %PLATFORM%==x86 (set MSYS2_PLATFORM=i686) else set MSYS2_PLATFORM=x86_64
    if %PLATFORM%==x86 (set MSYS2_MSYSTEM=MINGW32) else set MSYS2_MSYSTEM=MINGW64
    if %PLATFORM%==x86 (set MSYS2_PREFIX=C:\msys64\mingw32) else set MSYS2_PREFIX=C:\msys64\mingw64
    if "%APPVEYOR_REPO_TAG%"=="false" set TAG=rem
    %MSYS2% set PATH=%MSYS2_PREFIX%\bin;%PATH%
    choco install -y winflexbison3
    %MSVC% vcpkg install sdl2:%PLATFORM%-windows sdl2-image:%PLATFORM%-windows sdl2-mixer:%PLATFORM%-windows expat:%PLATFORM%-windows glew:%PLATFORM%-windows
    %MSYS2% C:\msys64\usr\bin\pacman -S --needed --noconfirm mingw-w64-%MSYS2_PLATFORM%-cmake mingw-w64-%MSYS2_PLATFORM%-SDL2 mingw-w64-%MSYS2_PLATFORM%-SDL2_image mingw-w64-%MSYS2_PLATFORM%-SDL2_mixer mingw-w64-%MSYS2_PLATFORM%-expat mingw-w64-%MSYS2_PLATFORM%-glew
before_build:
  - |-
    mkdir %APPVEYOR_BUILD_FOLDER%\build
    cd %APPVEYOR_BUILD_FOLDER%\build
    %MSVC% cmake -G"Visual Studio 15 2017%MSVC_GENERATOR_APPEND%" -DCMAKE_BUILD_TYPE=Release -DCMAKE_TOOLCHAIN_FILE=c:\tools\vcpkg\scripts\buildsystems\vcpkg.cmake ..
    %MSYS2% cmake -G"MinGW Makefiles" -DCMAKE_BUILD_TYPE=Release -DCMAKE_PREFIX_PATH="%MSYS2_PREFIX%" -DCMAKE_IGNORE_PATH="C:/Program Files/Git/usr/bin" ..
build_script:
  - |-
    cmake --build . --config Release
after_build:
  - |-
    %MSVC% %TAG% cpack -G ZIP -C Release
    %MSVC% %TAG% cpack -G WIX -C Release
artifacts:
  - path: 'build/*.zip'
    name: portable
  - path: 'build/*.msi'
    name: installer
deploy:
  description: ''
  provider: GitHub
  auth_token:
    secure: 655VE6bB1PIZDNNyr0uqKhE8cvNd31/rY3gfG3jJobNOhSBTACLiMBxYYUjgcFDU
  tag: $(APPVEYOR_REPO_TAG_NAME)
  release: DreamChess $(APPVEYOR_REPO_TAG_NAME)
  artifact: portable, installer
  draft: true
  force_update: true
  on:
    appveyor_repo_tag: true
